/**
 * Custom helper class to encapsulate the various pieces of information
 * for a given service. This helper class helps to organize service info
 * after it has been retrieved from the registry.
 *
 * @author Aaron E. Walsh
 * Copyright 2003, Web3D Web. All Rights Reserved.
 * Use subject to license terms: http://web3Dweb.com/license
 */

class ServiceInfo {
    private String serviceName, serviceDescription, bindingDescription, accessURI;
    
    /**
     * Default no-argument constructor that creates an empty Service object
     */
    public ServiceInfo() {
    }
    
    /**
     * Public constructor to build a fully populated Service object
     */
    public ServiceInfo(String serviceName, String serviceDescription, String bindingDescription, String accessURI) {
        this.serviceName = serviceName;
        this.serviceDescription = serviceDescription;
        this.bindingDescription = bindingDescription;
        this.accessURI = accessURI;
    }

    // Setter methods that set specific information about this service
    public void setServiceName(String serviceName)                   { this.serviceName = serviceName; }
    public void setServiceDescription(String serviceDescription)     { this.serviceDescription = serviceDescription; }
    public void setBindingDescription(String bindingDescription)     { this.bindingDescription = bindingDescription; }
    public void setAccessURI(String accessURI)                       { this.accessURI = accessURI; }
    
    
    // Getter methods that return specific information about this service
    public String getServiceName()          { return serviceName; }
    public String getServiceDescription()   { return serviceDescription; }
    public String getBindingDescription()   { return bindingDescription; }
    public String getAccessURI()            { return accessURI; }
    
}




