package com.mindsnack.mail;

import com.mindsnack.transactions.Validatable;

public class MailMessageData
  implements Validatable
{
  private String from;
  public void setFrom(String from) { this.from = from; }
  public String getFrom() { return from; }

  private String to;
  public void setTo(String to) { this.to = to; }
  public String getTo() { return to; }

  private String subject;
  public void setSubject(String subject) { this.subject = subject; }
  public String getSubject() { return subject; }

  private String body = "";
  public void setBody(String body) { this.body = body; }
  public void addToBody(String newBody) { this.body += newBody; }
  public String getBody() { return body; }

  public MailMessageData() {}

  public MailMessageData(String from, String to, String subject)
  {
    setFrom(from);
    setTo(to);
    setSubject(subject);
  }

  private boolean validAddress(String address)
  {
    int index = address.indexOf('@');
    if (index < 0) return false;
    return (index == address.lastIndexOf('@'));
  }

  public boolean isValid()
  {
    return validAddress(from) && validAddress(to) && (subject != null) && (body != null);
  }
}
