package com.mindsnack.mail;

import com.mindsnack.transactions.Copier;

public class MailSenderBeanCopier
  implements Copier
{

  public void copy(Object fromObject, Object toObject)
  {
    if (! (fromObject instanceof MailSenderBean))
    {
      String errorMessage
        = "'From' Object in MailSenderBeanCopier.copy(from,to) is not a MailSenderBean";
      throw new ClassCastException(errorMessage);
    }

    if (! (toObject instanceof MailSenderBean))
    {
      String errorMessage
        = "'To' Object in MailSenderBeanCopier.copy(from,to) is not a MailSenderBean";
      throw new ClassCastException(errorMessage);
    }

    MailSenderBean from = (MailSenderBean) fromObject;
    MailSenderBean to = (MailSenderBean) toObject;

    to.data = from.data;
    to.smtpServer = from.smtpServer;
    to.inTransaction = from.inTransaction;
    to.needToSend = from.needToSend;
    to.numMailsActuallySent = from.numMailsActuallySent;
  }
}
