package com.mindsnack.order;

import com.mindsnack.transactions.Copier;

public class OrderCopier implements Copier
{
  public void copy(Object fromObject, Object toObject)
  {
    if (! (fromObject instanceof Order))
    {
      String errorMessage
        = "'From' Object in OrderCopier.copy(from,to) is not an Order";
      throw new ClassCastException(errorMessage);
    }

    if (! (toObject instanceof Order))
    {
      String errorMessage
        = "'To' Object in OrderCopier.copy(from,to) is not an Order";
      throw new ClassCastException(errorMessage);
    }

    OrderImpl from = (OrderImpl) fromObject;
    OrderImpl to = (OrderImpl) toObject;

    to.contents.clear();
    to.contents.addAll( from.contents );
  }
}
