package com.mindsnack.order;

import java.util.ArrayList;

public class OrderImpl
  implements Order
{
  ArrayList contents = new ArrayList();

  public OrderImpl() { }

  public void addItem(String item)
    throws ItemNotAvailableException
  {
    item = item.trim();
    if ((item == null) || ("".equals(item)))
      throw new IllegalArgumentException("Can't add a null.");
    if (isAvailable(item))
      contents.add(item);
    else
      throw new ItemNotAvailableException(item);
  }

  private boolean isAvailable(String item)
  {
    // Carrot Beer is not available.
    return ! item.matches("[Cc]arrot(\\s*)[Bb]eer");
  }

  public String getItem(int index)
    { return (String) contents.get(index); }

  public int getNumItems()
    { return contents.size();}

  public void clear()
    { contents.clear(); }

  public String toString()
    { return   "Order contains " + contents; }
}
