package com.mindsnack.test;

import java.io.InputStream;
import java.util.Date;
import java.util.Properties;

import junit.framework.TestCase;

import com.mindsnack.transactions.Transaction;
import com.mindsnack.transactions.SimpleTransaction;

import com.mindsnack.mail.*;

public class TestMail extends TestCase
{

  static Properties properties = new Properties();
  static int counter = 1;
  final static String MAIL_PROPERTIES_FILE = "mail.properties";
  static {
    InputStream is= TestMail.class.getResourceAsStream(MAIL_PROPERTIES_FILE);
    if (is != null)
      try { properties.load(is); } catch (Exception ignore) {}
  }


  public void testGoodMail()
  {
    MailMessageData mail = new MailMessageData();
    mail.setFrom( properties.getProperty("mail.from") );
    mail.setTo( properties.getProperty("mail.to") );
    mail.setSubject(counter++ + " Good Mail " + new Date());
    mail.setBody("Hello");
    String smtpServer = properties.getProperty("mail.smtp.server");
    MailSender mailSender = new MailSenderBean(mail, smtpServer );

    Transaction transaction = new SimpleTransaction();
    mailSender = (MailSender) transaction.addToTransaction(mailSender, new MailSenderBeanCopier());
    transaction.begin();
    {
      mailSender.send();
    }
    transaction.commit(); // the mail should be sent.
  }

  public void testBadMail()
  {
    MailMessageData mail = new MailMessageData();
    mail.setFrom( properties.getProperty("mail.from") );
    mail.setTo( properties.getProperty("mail.to") );
    mail.setSubject(counter++ + " Bad Mail " + new Date());
    mail.setBody("Hello - You should not receive this mail");
    String smtpServer = properties.getProperty("mail.smtp.server");
    MailSender mailSender = new MailSenderBean(mail, smtpServer );

    Transaction transaction = new SimpleTransaction();
    mailSender = (MailSender) transaction.addToTransaction(mailSender, new MailSenderBeanCopier());
    transaction.begin();
    {
      mailSender.send();
      transaction.setRollbackOnly();
    }
    transaction.commit();  // the mail should not be sent.
  }
}
