package com.mindsnack.test;

import junit.framework.TestCase;

import com.mindsnack.transactions.SimpleTransaction;
import com.mindsnack.transactions.Transaction;

import com.mindsnack.order.*;

public class TestOrder extends TestCase
{
  public static void main(String args[])
  {
    if (args.length > 0 && args[0].equals("gui"))
      junit.swingui.TestRunner.run(TestOrder.class);
    else
      junit.textui.TestRunner.run(TestOrder.class);
  }


  public void testSimpleOrder()
  {
    Transaction transaction = new SimpleTransaction();

    Order o1 = new OrderImpl();
    Order o2 = new OrderImpl();
    OrderCopier orderCopier = new OrderCopier();

    Order order1 = (Order) transaction.addToTransaction( o1, orderCopier );
    Order order2 = (Order) transaction.addToTransaction( o2, orderCopier );


    transaction.begin();
    {
      try {
        order1.addItem("Pizza");
        assertTrue( order1.getNumItems() == 1);
        order2.addItem("Carrot Beer");  // this should throw an exception.
      } catch (ItemNotAvailableException e)
        { transaction.setRollbackOnly(); }
    }
    transaction.commit();  // Should actually do a rollback

    int items = order1.getNumItems();
    assertTrue(order1.getNumItems()  == 0 );
  }
}
