package com.mindsnack.transactions;

import java.lang.reflect.Array;
import java.lang.reflect.Field;

public class PlainCopier
  implements Copier
{
  public void copy(Object from, Object to)
  {
    Class fromClass = from.getClass();
    if (fromClass != to.getClass())
      throw new IllegalArgumentException();

    for (;fromClass != null;fromClass=fromClass.getSuperclass())
    {
      Field[] fields = fromClass.getDeclaredFields();
      for (int i=0; i<fields.length; i++)
      {
        try {
          Field field = fields[i];
          field.setAccessible(true);
          Object value = field.get(from);
          field.set(to, value);
        } catch (IllegalAccessException ignore) {}
      }
    }
  }
}