package com.mindsnack.triangles;

import com.mindsnack.transactions.Copier;

public class TriangleCopier implements Copier
{
  public void copy(Object fromObject, Object toObject)
  {
    if (! (fromObject instanceof Triangle))
    {
      String errorMessage
        = "'From' Object in TriangleCopier.copy(from,to) is not a Triangle";
      throw new ClassCastException(errorMessage);
    }
    if (! (toObject instanceof Triangle))
    {
      String errorMessage
        = "'To' Object in TriangleCopier.copy(from,to) is not a Triangle";
      throw new ClassCastException(errorMessage);
    }

    Triangle from = (Triangle) fromObject;
    Triangle to = (Triangle) toObject;

    to.setAngle(1,  from.getAngle(1));
    to.setAngle(2,  from.getAngle(2));
    to.setAngle(3,  from.getAngle(3));
  }
}
