package com.mindsnack.triangles;

import com.mindsnack.transactions.Validatable;

public class TriangleImpl
  implements Triangle, Validatable
{
  public TriangleImpl() {}

  public TriangleImpl(double[] vertices)
  {
    for (int i=0; i<vertices.length; i++)
      setAngle(i,vertices[i]);
  }

  public TriangleImpl(double angle1, double angle2, double angle3)
  {
    setAngle(1, angle1);
    setAngle(2, angle2);
    setAngle(3, angle3);
  }

  private double vertices[] = new double[3];

  public double getAngle(int vertex)
    { return vertices[vertex-1]; }

  public void setAngle(int vertex, double angle)
  {
    if ((vertex < 1) || (vertex > 3))
    {
      String error = "vertex parameter has value " + vertex
                   + ". It must be between 1 and 3";
      throw new IllegalArgumentException( error );
    }

    if ((angle <= 0.0) || (angle >= 180.0))
    {
      String error = "angle Parameter has value " + angle
                   + ". It must be: 0 < Angle < 180";
      throw new IllegalArgumentException( error );
    }

    vertices[vertex-1] = angle;
  }

  public double getTotalAngle()
    { return getAngle(1) + getAngle(2) + getAngle(3); }


  public boolean isValid()
    { return Math.abs(getTotalAngle() - 180.0) < 0.001; }

  public String toString()
  {
    return   "[" + getAngle(1)
           + "," + getAngle(2)
           + "," + getAngle(3) + "]";
  }
}
