package com.ericgiguere;

import java.awt.*;

/**
 * A _very_ simple UI component that draws a
 * centered text string.
 */

public class SimpleTextLabel extends Component {
    private String text;

    public SimpleTextLabel( String text ){
        this.text = text;
    }

    public void paint( Graphics g ){
        int h = getHeight();
        int w = getWidth();

        g.setColor( getBackground() );
        g.fillRect( 0, 0, w, h );

        g.setColor( getForeground() );
        FontMetrics fm = g.getFontMetrics();
        int textWidth = fm.stringWidth( text );
        int textHeight = fm.getHeight();
        int x = ( w - textWidth ) / 2;
        int y = ( h - 2 * textHeight ) / 2;
        g.drawString( text, x, y );
    }
}
